Index: trunk/LMDZ.MARS/libf/phymars/physiq_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 1708)
+++ trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 1711)
@@ -14,4 +14,7 @@
      $            ,pdu,pdv,pdt,pdq,pdpsrf)
 
+      use watercloud_mod
+      use aeropacity_mod
+      use callradite_mod 
       use tracer_mod, only: noms, mmol, igcm_co2, igcm_n2, igcm_co2_ice,
      &                      igcm_co, igcm_o, igcm_h2o_vap, igcm_h2o_ice,
@@ -386,4 +389,19 @@
 !      REAL zu2(ngrid)
 
+c sub-grid scale water ice clouds (A. Pottier 2013)
+      logical clearsky
+      ! flux for the part without clouds
+      real zdtsw1(ngrid,nlayer)
+      real zdtlw1(ngrid,nlayer)
+      real fluxsurf_lw1(ngrid)     
+      real fluxsurf_sw1(ngrid,2)  
+      real fluxtop_lw1(ngrid)
+      real fluxtop_sw1(ngrid,2) 
+      REAL taucloudtes1(ngrid)
+      ! tf: fraction of clouds, ntf: fraction without clouds
+      real tf, ntf
+      real,allocatable,dimension(:),save :: totcloudfrac ! total cloud fraction over the column
+      REAL rave2(ngrid), totrave2(ngrid) ! Mean water ice mean radius (m)
+
 c=======================================================================
 
@@ -394,4 +412,9 @@
 c  ---------------------------------------
       IF (firstcall) THEN
+        ALLOCATE(totcloudfrac(ngrid)) !A. Pottier: souci avec ca a priori, tentative
+                                      ! de les allouer dans dimradmars_mod.F90 
+        !ouverture de nebuldata.out et nettoyage du precedent
+         open(144,file="nebuldata.out")
+         close(144,status="delete")
 
 c        variables set to 0
@@ -412,5 +435,6 @@
      &         nsoilmx,ngrid,nlayer,nq,
      &         day_ini,time_phys,
-     &         tsurf,tsoil,emis,q2,qsurf,co2ice,tauscaling)
+     &         tsurf,tsoil,emis,q2,qsurf,co2ice,tauscaling,
+     &         totcloudfrac)
 
          if (pday.ne.day_ini) then
@@ -552,4 +576,8 @@
          call solarlong(float(day_ini),zls)
       end if
+      !A. Pottier: checking nebuldata.out
+      open(14,file="nebuldata.out",position="append")
+      write(14,*) "LsEtJour ",zls*180/pi,zday
+      close(14)
 
 c     Initialize pressure levels
@@ -699,11 +727,51 @@
 c          Radiative transfer
 c          ------------------
-
+           ! callradite for the part with clouds
+           clearsky=.false. ! part with clouds for both cases CLFvarying true/false 
            CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,albedo,
      $     emis,mu0,zplev,zplay,pt,tsurf,fract,dist_sol,igout,
      $     zdtlw,zdtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,fluxtop_sw,
      $     tauref,tau,aerosol,dsodust,tauscaling,taucloudtes,rdust,rice,
-     $     nuice,co2ice)
-
+     $     nuice,co2ice,clearsky,totcloudfrac)
+           ! case of sub-grid water ice clouds: callradite for the clear case
+            IF (CLFvarying) THEN
+               ! ---> PROBLEMS WITH ALLOCATED ARRAYS 
+               ! (temporary solution in callcorrk: do not deallocate
+               ! if
+               ! CLFvarying ...) ?? AP ??
+               clearsky=.true. ! 
+               CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,
+     &              albedo,emis,mu0,zplev,zplay,pt,tsurf,fract,
+     &              dist_sol,igout,zdtlw1,zdtsw1,fluxsurf_lw1,
+     &              fluxsurf_sw1,fluxtop_lw1,fluxtop_sw1,tauref,tau,
+     &              aerosol,dsodust,tauscaling,taucloudtes1,rdust,
+     &              rice,nuice,co2ice, clearsky, totcloudfrac)
+               clearsky = .false.  ! just in case.
+               ! Sum the fluxes and heating rates from cloudy/clear
+               ! cases
+               DO ig=1,ngrid
+                  tf=totcloudfrac(ig)
+                  ntf=1.-tf
+                  fluxsurf_lw(ig) = ntf*fluxsurf_lw1(ig) 
+     &                                          + tf*fluxsurf_lw(ig)
+                  fluxsurf_sw(ig,1) = ntf*fluxsurf_sw1(ig,1) 
+     &                                          + tf*fluxsurf_sw(ig,1)
+                  fluxsurf_sw(ig,2) = ntf*fluxsurf_sw1(ig,2) 
+     &                                          + tf*fluxsurf_sw(ig,2)
+                  fluxtop_lw(ig)  = ntf*fluxtop_lw1(ig) 
+     &                                          + tf*fluxtop_lw(ig)
+                  fluxtop_sw(ig,1)  = ntf*fluxtop_sw1(ig,1)  
+     &                                          + tf*fluxtop_sw(ig,1)
+                  fluxtop_sw(ig,2)  = ntf*fluxtop_sw1(ig,2)  
+     &                                          + tf*fluxtop_sw(ig,2)
+                  taucloudtes(ig) = ntf*taucloudtes1(ig) 
+     &                                          + tf*taucloudtes(ig)
+                  zdtlw(ig,1:nlayer) = ntf*zdtlw1(ig,1:nlayer) 
+     &                                         + tf*zdtlw(ig,1:nlayer)
+                  zdtsw(ig,1:nlayer) = ntf*zdtsw1(ig,1:nlayer) 
+     &                                         + tf*zdtsw(ig,1:nlayer)
+               ENDDO
+
+            ENDIF ! (CLFvarying)
 
 #ifdef DUSTSTORM
@@ -1082,5 +1150,5 @@
      &                pq,pdq,zdqcloud,zdtcloud,
      &                nq,tau,tauscaling,rdust,rice,nuice,
-     &                rsedcloud,rhocloud)
+     &                rsedcloud,rhocloud,totcloudfrac)
      
 c Temperature variation due to latent heat release
@@ -1740,5 +1808,6 @@
           call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq,
      .                ptimestep,ztime_fin,
-     .                tsurf,tsoil,co2ice,emis,q2,qsurf,tauscaling)
+     .                tsurf,tsoil,co2ice,emis,q2,qsurf,tauscaling,
+     .               totcloudfrac)
           
          ENDIF
@@ -1844,4 +1913,15 @@
                enddo
              endif ! of if (scavenging)
+
+           !Alternative A. Pottier weighting
+           rave2(:) = 0.
+           totrave2(:) = 0.
+           do ig=1,ngrid
+              do l=1,nlayer
+              rave2(ig) =rave2(ig)+ zq(ig,l,igcm_h2o_ice)*rice(ig,l)
+              totrave2(ig) = totrave2(ig) + zq(ig,l,igcm_h2o_ice)
+              end do
+              rave2(ig)=max(rave2(ig)/max(totrave2(ig),1.e-30),1.e-30)
+           end do
 
            endif ! of if (water)
@@ -2388,4 +2468,8 @@
      &                       'Mean reff',
      &                       'm',2,rave)
+!A. Pottier
+             CALL WRITEDIAGFI(ngrid,'rmoym',
+     &                      'alternative reffice',
+     &                      'm',2,rave2)
             call WRITEDIAGFI(ngrid,'saturation',
      &           'h2o vap saturation ratio','dimless',3,satu)
@@ -2414,4 +2498,11 @@
      &                       'J.s-1/2.m-2.K-1',3,inertiesoil)
               endif
+!A. Pottier
+              if (CLFvarying) then !AP14 nebulosity
+                 call WRITEDIAGFI(ngrid,'totcloudfrac',
+     &                'Total cloud fraction',
+     &                       ' ',2,totcloudfrac)
+              endif !clf varying
+
            endif !(water)
 
@@ -2885,4 +2976,16 @@
      &                      'm',0,rave)
 
+          !Alternative A. Pottier weighting
+           rave2 = 0.
+           totrave2 = 0.
+           do l=1,nlayer
+              rave2 =rave2+ zq(1,l,igcm_h2o_ice)*rice(1,l)
+              totrave2 = totrave2 + zq(1,l,igcm_h2o_ice)
+           end do
+           rave2=max(rave2/max(totrave2,1.e-30),1.e-30)
+          CALL WRITEDIAGFI(ngrid,'rmoym',
+     &                      'reffice',
+     &                      'm',0,rave2)
+
            do iq=1,nq
              call WRITEDIAGFI(ngrid,trim(noms(iq))//'_s',
@@ -2898,6 +3001,13 @@
      &                          +zdqcloud(1,:,igcm_h2o_vap))
      
-          call WRITEDIAGFI(ngrid,"rice","ice radius","m",1,
+        call WRITEDIAGFI(ngrid,"rice","ice radius","m",1,
      &                    rice)
+              
+              if (CLFvarying) then
+                 call WRITEDIAGFI(ngrid,'totcloudfrac',
+     &                'Total cloud fraction',
+     &                       ' ',0,totcloudfrac)
+              endif !clfvarying
+
          ENDIF ! of IF (water)
          
Index: trunk/LMDZ.MARS/libf/phymars/tcondwater.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/tcondwater.F90	(revision 1711)
+++ trunk/LMDZ.MARS/libf/phymars/tcondwater.F90	(revision 1711)
@@ -0,0 +1,71 @@
+SUBROUTINE tcondwater(nbpts,p,q,tcond)
+IMPLICIT NONE 
+
+!---------------------------------------------------
+! Condensation temperature for water ice; based on 
+! the saturation in watersat.F AP14
+!--------------------------------------------------i
+
+integer, intent(in) :: nbpts
+real, intent(in), dimension(nbpts):: p,q
+real, intent(out), dimension(nbpts):: tcond
+
+real, dimension(nbpts):: res
+real:: x
+integer:: i
+
+do i=1,nbpts
+   !write(*,*) "i en cours", i, "sur nbpts=", nbpts
+   !write(*,*) "q(i)",q(i),"p(i)",p(i)
+   x=alog10(MAX(q(i),1e-16)*p(i)/(100.*0.41)) ! max pour erreur q<=0
+   ! attention change le 0.41 de place le 10 juin 2014 car priorites
+   ! fortran dans watersat.F
+   !write(*,*) "x tcondwater AP14! :) :) :) :P", x
+   !res(i) = 2.52826991e+02+ 2.39287870e+01*x+ 2.27275932e+00*x**2
+   !        + 2.21832905e-01*x**3+ 2.23453930e-02*x**4+2.26075106e-03*x**5
+   !        + 2.12411064e-04*x**6+1.64642075e-05*x**7+9.22615632e-07*x**8
+   !        + 3.18958825e-08*x**9+5.00656720e-10*x**10 degre 10: trop!
+   res(i) = 2.52846556e+02+ 2.39229653e+01*x+ 2.21333897e+00*x**2  &
+                + 1.79977992e-01*x**3+ 1.00068175e-02*x**4+2.55145012e-04*x**5
+   !write(*,*) "rex(x) tcondwater AP14! :) :) :) :P", res(i)
+enddo
+
+tcond=res
+
+return 
+end
+!polynome de degre 5 pas 0.0001
+!polynomial coefs [  2.52846556e+02   2.39229653e+01   2.21333897e+00
+!1.79977992e-01
+!   1.00068175e-02   2.55145012e-04]
+!maximum des abs(difference) 0.0604390646026
+
+! polynome de degre 12
+!polynomial coefs [  2.52826992e+02   2.39287716e+01   2.27274870e+00
+!2.21863471e-01
+ !  2.23765903e-02   2.26605393e-03   2.07841624e-04   1.37374700e-05
+ !  2.45106231e-07  -6.16151111e-08  -6.96026651e-09  -3.22690558e-10
+!  -5.86804217e-12]   maximum des abs(difference) 2.73827428146e-05
+! polynome de degre 6
+!polynomial coefs [  2.52831053e+02   2.39333049e+01   2.26006967e+00
+!2.06350715e-01
+!   1.56882616e-02   7.83034223e-04   1.77637297e-05] 
+!maximum des abs(difference) 0.013723768413
+! polynome de degre 8
+! polynomial coefs [  2.52827042e+02   2.39294477e+01   2.27281607e+00
+!2.20637577e-01
+!   2.12491384e-02   1.82810482e-03   1.19638702e-04   4.91167244e-06
+!   9.12272144e-08]
+!maximum des abs(difference) 0.000725035990172
+!polynome de degre 9
+!polynomial coefs [  2.52826985e+02   2.39289186e+01   2.27286626e+00
+!2.21623591e-01
+!   2.20538443e-02   2.11335665e-03   1.73307328e-04   1.04920165e-05
+!   3.94201385e-07   6.70874574e-09]
+!maximum des abs(difference) 0.000168806463876
+!polynome de degre 10
+!polynomial coefs [  2.52826991e+02   2.39287870e+01   2.27275932e+00
+!2.21832905e-01
+!   2.23453930e-02   2.26075106e-03   2.12411064e-04   1.64642075e-05
+!   9.22615632e-07   3.18958825e-08   5.00656720e-10]
+!maximum des abs(difference) 3.96286844477e-05
